config/routes.rb
ELMO::Application.routes.draw do

  get 'option_set_related_forms/new'
  get 'option_set_related_forms/create'
  mount JasmineRails::Engine => "/specs" if defined?(JasmineRails)

  # Special shortcut for simulating login in feature specs.
  get "test-login" => "user_sessions#test_login" if Rails.env.test?

  # For uptime checking
  get "ping" => "ping#show"

  #####################################
  # Basic routes (neither mission nor admin mode)
  scope ":locale", locale: /[a-z]{2}/, defaults: {mode: nil, mission_name: nil} do

    # Routes requiring no user.
    resources :password_resets, path: "password-resets", only: %i[new edit create update]
    resource :user_session, path: "user-session", only: %i[new create destroy]
    get "/logged-out" => "user_sessions#logged_out", as: :logged_out
    get "/login" => "user_sessions#new", as: :login

    # Routes requiring user.
    match "/logout" => "user_sessions#destroy", as: :logout, via: [:delete]
    get "/route-tests" => "route_tests#basic_mode" if Rails.env.development? || Rails.env.test?
    get "/unauthorized" => "welcome#unauthorized", as: :unauthorized

    get "/confirm-login" => "user_sessions#login_confirmation", defaults: { confirm: true }, as: :new_login_confirmation
    post "/confirm-login" => "user_sessions#process_login_confirmation", defaults: { confirm: true }, as: :login_confirmation

    # Routes with user or no user.
    root to: "welcome#index", as: :basic_root
  end

  #####################################
  # Admin-mode-only routes
  scope ":locale/admin", locale: /[a-z]{2}/, defaults: {mode: "admin", mission_name: nil} do
    resources :missions

    get "/route-tests" => "route_tests#admin_mode" if Rails.env.development? || Rails.env.test?

    # for /en/admin
    root to: "welcome#index", as: :admin_root
  end

  #####################################
  # Mission-mode-only routes
  scope ":locale/m/:mission_name", locale: /[a-z]{2}/, mission_name: /[a-z][a-z0-9]*/, defaults: {mode: "m"} do
    resources :broadcasts, only: %i[index show new create] do
      collection do
        get "possible-recipients", as: "possible_recipients", action: "possible_recipients"
        post "new-with-users", as: "new_with_users", action: "new_with_users"
      end
    end

    resources :responses do
      collection do
        post "bulk-destroy", as: "bulk_destroy", action: "bulk_destroy"

        get "possible-submitters", as: "possible_submitters", action: "possible_submitters"
        get "possible-reviewers", as: "possible_reviewers", action: "possible_reviewers"
      end
    end

    resources :sms, only: [:index] do
      collection do
        get "incoming-numbers", as: "incoming_numbers", action: "incoming_numbers", defaults: { format: "csv" }
      end
    end

    resources :sms_tests, path: "sms-tests", only: %i[new create]

    resources :reports do
      member do
        get "data"
      end
    end

    namespace :media, type: /audios|images|videos/ do
      resources :objects, path: ":type", only: %i[show create destroy]
    end

    # need to list these all separately b/c rails is dumb sometimes
    resources :answer_tally_reports, controller: "reports"
    resources :response_tally_reports, controller: "reports"
    resources :list_reports, controller: "reports"
    resources :standard_form_reports, controller: "reports"

    # special dashboard routes
    get "/info-window" => "welcome#info_window", as: :dashboard_info_window
    get "/route-tests" => "route_tests#mission_mode" if Rails.env.development? || Rails.env.test?

    # for /en/m/mission123
    root to: "welcome#index", as: :mission_root
  end

  #####################################
  # Admin mode OR mission mode routes
  scope ":locale/:mode(/:mission_name)", locale: /[a-z]{2}/, mode: /m|admin/, mission_name: /[a-z][a-z0-9]*/ do

    # the rest of these routes can have admin mode or not
    resources :forms, constraints: -> (req) { req.format == :html } do
      member do
        post "add-questions", as: "add_questions", action: "add_questions"
        put "clone"
        put "publish"
        get "choose-questions", as: "choose_questions", action: "choose_questions"
        get "sms-guide", as: "sms_guide", action: "sms_guide"
      end
    end
    resources :operations, only: %i[index show destroy] do
      collection do
        post "clear"
      end
      member do
        get "download"
      end
    end
    resources :questions do
      collection do
        post "bulk-destroy", as: "bulk_destroy", action: "bulk_destroy"
      end

      member do
        # odk needs to be able to download media prompts
        get "media_prompt", defaults: {direct_auth: "basic"}
        get "audio_prompt", defaults: {direct_auth: "basic"}, action: :media_prompt # Legacy endpoint
      end
    end
    resources :questionings, only: %i[show edit create update destroy]
    resources :qing_groups, path: "qing-groups", only: %i[new edit create show update destroy]
    resources :settings, only: %i[index update] do
      member do
        post "regenerate_override_code"
        post "regenerate_incoming_sms_token"
      end
      collection do
        get "using_incoming_sms_token_message"
      end
    end

    resources :user_imports, path: "user-imports", only: %i[new create] do
      collection do
        get :template
        post :upload
      end
    end

    resources :user_groups, only: %i[index edit update create destroy] do
      post "add_users"
      post "remove_users"
      collection do
        get "possible-groups", as: "possible_groups", action: "possible_groups"
      end
    end

    resources :form_items, path: "form-items", only: [:update]

    resources :option_sets, path: "option-sets" do
      member do
        get "child-nodes", as: "child-nodes", action: "child_nodes"
        put "clone"
        get "export", defaults: {format: "xlsx"}
      end
    end

    resources :option_set_imports, path: "option-set-imports", only: [:new, :create] do
      collection do
        get :template
        post :upload
      end
    end

    resources :option_set_related_forms, path: "option-set-related-forms", only: [:new, :create] do
      collection do
        get :template
        post :upload
      end
    end

    # import routes for standardizeable objects
    %w(forms questions option_sets).each do |k|
      post "/#{k.gsub('_', '-')}/import-standard" => "#{k}#import_standard", as: "import_standard_#{k}"
    end

    # Non-RESTful, JSON only controllers for React
    get "/condition-form-data/base" => "condition_form_data#base"
    get "/condition-form-data/option-path" => "condition_form_data#option_path"
    get "/filter-data/qings" => "filter_data#qings"

    # special routes for tokeninput suggestions
    get "/tags/suggest" => "tags#suggest", as: :suggest_tags
  end

  #####################################
  # Any mode routes
  scope ":locale(/:mode)(/:mission_name)", locale: /[a-z]{2}/, mode: /m|admin/, mission_name: /[a-z][a-z0-9]*/ do
    resources :users do
      member do
        get "login-instructions", as: "login_instructions", action: "login_instructions"
        post "regenerate_api_key"
        post "regenerate_sms_auth_code"
      end
      collection do
        post "export"
        post "bulk-destroy", as: "bulk_destroy", action: "bulk_destroy"
      end
    end
  end

  # Special SMS routes. No locale.
  def sms_submission_route(as:)
    match "/sms/submit/:token" => "sms#create", token: /[0-9a-f]{32}/, via: [:get, :post], as: as
  end
  scope "/m/:mission_name", mission_name: /[a-z][a-z0-9]*/, defaults: { mode: "m"} do
    sms_submission_route(as: :mission_sms_submission)
  end
  sms_submission_route(as: :missionless_sms_submission)

  # Special ODK routes. No locale. They are down here so that forms_path doesn't return the ODK variant.
  #
  # NOTE: Brute-force login protection happens in the rack-attack middleware,
  # which executes before routing. Be sure that all paths marked with
  # :direct_auth => true are also matched by the direct_auth? method in
  # config/initializers/rack-attack.rb
  scope "(/:locale)/m/:mission_name", mission_name: /[a-z][a-z0-9]*/, defaults: { mode: "m", direct_auth: "basic" }, constraints: -> (req) { req.format == :xml || req.format == :csv } do
    get "/formList" => "forms#index", as: :odk_form_list, defaults: {format: "xml"}
    get "/forms/:id" => "forms#show", as: :odk_form, defaults: {format: "xml"}
    get "/forms/:id/manifest" => "forms#odk_manifest", as: :odk_form_manifest, defaults: {format: "xml"}
    get "/forms/:id/itemsets" => "forms#odk_itemsets", as: :odk_form_itemsets, defaults: {format: "csv"}

    match "/submission" => "responses#odk_headers", via: [:head, :get], defaults: { format: "xml" }
    post "/submission" => "responses#create", defaults: { format: "xml" }
  end

  # API routes.
  namespace :api, defaults: { format: :json } do
    api_version module: "v1", path: { value: "v1"} do
      scope "/m/:mission_name", mission_name: /[a-z][a-z0-9]*/, defaults: {mode: "m"} do
        resources :forms, only: [:index, :show]
        resources :responses, only: :index
        resources :answers, only: :index
      end
    end
  end

  root to: redirect("/#{I18n.default_locale}")
end

app/models/welcome.rb
# this is just a dummy class for use with Ability
class Welcome
end

app/controllers/welcome_controller.rb
class WelcomeController < ApplicationController
  include ReportEmbeddable
  include ResponseIndexable

  # Don't need to authorize since we manually redirect to login if no user.
  # This is because anybody is 'allowed' to see the root and letting the auth system handle things
  # leads to nasty messages and weird behavior. We merely redirect because otherwise the page would be blank
  # and not very interesting.
  # We also skip the check for unauthorized because who cares if someone sees it.
  skip_authorization_check only: %i[index unauthorized]

  # number of rows in the stats blocks
  STAT_ROWS = 3

  # shows a series of blocks with info about the app
  def index
    return redirect_to(login_path) unless current_user

    if current_mission
      # Dashboard has no title.
      @dont_print_title = true
      dashboard_index
    elsif admin_mode?
      render :admin
    else
      render :no_mission
    end
  end

   # map info window
  def info_window
    @response = Response.with_basic_assoc.find(params[:response_id])
    authorize!(:read, @response)
    render(layout: false)
  end

  def unauthorized
  end

  private

  def dashboard_index
    # we need to check for a cache fragment here because some of the below fetches are not lazy
    @cache_key = [
      # we include the locale in the cache key so the translations are correct
      I18n.locale.to_s,

      # obviously we include this
      Response.per_mission_cache_key(current_mission),

      # we include assignments in the cache key since users show up in low activity etc.
      # if a user gets removed or added to the mission, that should show up
      # but we don't include user's in the cache key since users get updated every request
      # and that would defeat the purpose
      Assignment.per_mission_cache_key(current_mission)
    ].join("-")

    # get a relation for accessible responses
    accessible_responses = Response.accessible_by(current_ability)

    # load objects for the view
    @responses = accessible_responses.with_basic_assoc.with_basic_answers.latest_first
    @responses = @responses.paginate(page: 1, per_page: 20)

    # total responses for this mission
    @total_response_count = accessible_responses.count

    # unreviewed response count
    @unreviewed_response_count = accessible_responses.unreviewed.count

    # do the non-lazy loads inside these blocks so they don't run if we get a cache hit
    unless fragment_exist?(@cache_key + "/js_init")
      # get location answers
      location_answers = Answer.location_answers_for_mission(current_mission, current_user)

      @location_answers_count = location_answers.total_entries
      @location_answers = location_answers.map { |a| [a.response_id, a.latitude, a.longitude] }
    end

    unless fragment_exist?(@cache_key + "/stat_blocks")
      # responses by form (top N most popular)
      @responses_by_form = Response.per_form(accessible_responses, STAT_ROWS)

      # responses per user
      @responses_per_user = User.sorted_enumerator_response_counts(current_mission, STAT_ROWS)
    end

    # get list of all reports for the mission, for the dropdown
    @reports = Report::Report.accessible_by(current_ability).by_name

    prepare_report

    # render JSON if ajax request
    if request.xhr?
      data = {
        recent_responses: render_to_string(partial: "recent_responses"),
        response_locations: {
          answers: @location_answers,
          count: @location_answers_count
        },
        report_stats: render_to_string(partial: "report_stats")
      }
      render json: data
    else
      render(:dashboard)
    end
  end

  def prepare_report
    # if report id given, load that else use most popular
    if !params[:report_id].blank?
      @report = Report::Report.find(params[:report_id])
    else
      @report = Report::Report.accessible_by(current_ability).by_popularity.first
    end

    if @report
      # Make sure no funny business!
      authorize!(:read, @report)

      # We don't run the report, that will happen on an ajax call.
      build_report_data(read_only: true, embedded_mode: true)
    end
  end
end

app/views/welcome/_recent_responses.html.erb
<div class="recent_responses">
  <%# cache the recent responses and use the explicit submit date instead of the age %>
  <% cache(@cache_key + '/recent_responses') do %>
    <% if responses.empty? %>
      <%= t('will_paginate.response.page_entries_info.single_page_html.zero') %>
    <% else %>
      <%= index_table(responses, klass: Response, table_only: true) %>
    <% end %>
  <% end %>

  <%# outside the cache block we need to tell the list view to highlight new responses %>
  <%= javascript_doc_ready do %>
    ELMO.app.dashboard.list_view.highlight_responses_after(<%=json params[:latest_response_id] %>)
  <% end %>
</div>

app/views/welcome/_report_pane.html.erb
<div class="report_pane">
<% if @reports.empty? %>
  <h2 class="interior"><%= translate_model(Report::Report) %></h2>
  <div class="report_main">
    <%= t('dashboard.no_reports') %>
  </div>
<% else %>
  <div>
    <form class="report_chooser">
      <%= select_tag('report_id', options_from_collection_for_select(@reports, 'id', 'name'), {:prompt => I18n.t('report/report.choose_report'), :class => 'form_control'}) %>
    </form>

    <div class="report_title">
      <%= render('report_pane_title') %>
    </div>
  </div>

  <div class="report_main">
    <%= render('reports/main') %>
  </div>
<% end %>
</div>

app/views/welcome/_report_pane_title.html.erb
<h2 class="interior">
  <span class="report_title_text"><%= t("report/report.loading_report") %></span>
</h2>
<span class="report_edit_link_container">
  &nbsp;&nbsp;<%= action_link(:edit, "#", label: false) %>
</span>

app/views/welcome/_report_stats.html.erb
<div class="report_stats">
  <div class="stat_block">
    <h2><%= t('dashboard.summary') %></h2>
    <ul>
      <%# expire this one in half an hour b/c it needs to be updated even if no new responses %>
      <% cache(@cache_key + '/recent_response_count', :expires_in => 30.minutes) do %>
        <li><%= link_to(translate_recent_responses(Response.recent_count(Response.accessible_by(current_ability))), responses_path) %></li>
      <% end %>

      <%# cache the rest of these though %>
      <% cache(@cache_key + '/stat_block_1') do %>
        <li><%= link_to(tmd("welcome.total_responses", :count => number_with_delimiter(@total_response_count)), responses_path) %></li>
        <li><%= link_to(tmd("welcome.awaiting_review", :count => number_with_delimiter(@unreviewed_response_count)), responses_path(:search => "reviewed:no")) %></li>
      <% end %>
    </ul>
  </div>
  <%# cache the rest of the stat blocks %>
  <% cache(@cache_key + '/stat_blocks') do %>
    <div class="stat_block">
      <% unless @responses.empty? %>
        <h2><%= t('dashboard.top_forms') %></h2>
        <ul>
          <% @responses_by_form.each do |row| %>
            <li>
              <%= link_to(content_tag(:strong, number_with_delimiter(row['count'])) + ' ' + row['form_name'],
                responses_path(:search => "form:\"#{row['form_name']}\"")) %>
            </li>
          <% end %>
        </ul>
      <% end %>
    </div>
    <% if current_user.role(current_mission) != 'enumerator' %>
      <div class="stat_block">
        <% unless @responses.empty? %>
          <h2><%= t('dashboard.low_activity') %></h2>
          <ul>
            <% @responses_per_user.each do |row| %>
              <li>
                <%= link_to(content_tag(:strong, number_with_delimiter(row.response_count)) + ' ' + row.name,
                  responses_path(:search => "submitter:\"#{row.name}\"")) %>
              </li>
              <% end %>
          </ul>
        <% end %>
      </div>
    <% end %>
  <% end %>
</div>

app/views/welcome/_response_locations.html.erb
<%# no need to cache this bit either because there's nothing here (done by JS) %>
<div class="response_locations"></div>
<div class="response_locations_offline" style="display: none"><%= t("common.map_offline") %></div>
<% if @location_answers_count > @location_answers.size %>
  <div class="response_locations_truncated">
    <%= t('dashboard.response_locations_truncated', shown: @location_answers.size, total: @location_answers_count) %>
  </div>
<% end %>

app/views/welcome/admin.html.erb
<% @title = "Admin Mode" %>
Please select from the nav bar.

app/views/welcome/dashboard.html.erb
<% content_for(:per_page_js) do
 # load the mapping API
 javascript_google_maps +

 # load report stuff
 report_js_includes
end %>

<% content_for(:audio) do %>
  <%# this path is hard coded because the audio_tag/path helpers are not working and i can't figure out why %>
  <%# they produce /audios/ship-bell.mp3 instead of the correct /assets/ship-bell.mp3 %>
  <%# so i moved the whole audios directory to /public for now %>
  <audio id="new_arrival_sound" src="/audios/ship-bell.mp3"></audio>
<% end %>

<%# cache the javascript initialization since it will only change if response added %>
<% cache(@cache_key + '/js_init') do %>

  <%# placing this up here so it's the first call to document.ready, so that the pane sizing happens before report drawing %>
  <%= javascript_doc_ready do %>
    // delete any previous instance
    delete ELMO.app.dashboard;

    ELMO.app.dashboard = new ELMO.Views.Dashboard(<%=json(
      # needed for storing the map bounds between refreshes
      mission_id: current_mission.id,
      map: {
        locations: @location_answers,
        info_window_url: dashboard_info_window_url,
        small_marker_url: image_url('markers/small.png')
      },
      report: {
        id: @report_id
      }
    )%>);
  <% end %>

<% end %>

<div class="row">
  <div class="col-md left_col">
    <h2>
      <%= current_user.role(current_mission) == 'enumerator' ? t('dashboard.my_responses') : t('dashboard.recent_responses') %>
    </h2>
    <%= render partial: 'recent_responses' %>

    <div>
      <a href="#" class="expand-map toggle-map">
        <i class="fa fa-expand"></i>
        <%= t("dashboard.expand_map") %>
      </a>
      <h2 class="interior">
        <%= t('dashboard.response_locations') %>
      </h2>
      <%= render partial: 'response_locations' %>
    </div>
  </div>

  <div class="col-md right_col">
    <%= render partial: 'report_stats' %>
    <%= render partial: 'report_pane' %>
  </div>
</div>

<%# Link for shrinking map. Shown only when expanded map is shown. %>
<div class="expanded-map-links">
  <a href="#" class="toggle-map">
    <i class="fa fa-compress"></i>
    <%= t("dashboard.shrink_map") %>
  </a>
</div>

<%= javascript_doc_ready do %>
  <%# Hides/displays appropriate full screen elements if necessary %>
  ELMO.app.dashboard.set_full_screen();
  ELMO.app.dashboard.set_expanded_map();

  <%# Runs report %>
  ELMO.app.dashboard.run_report();
<% end %>

<div class="dashboard-footer">
  <%# These links are for testing purposes %>
  <% if Rails.env.test? %>
    <a href="#" class="reload-ajax">Reload via AJAX</a>
    <a href="#" class="reload-page">Reload Page</a>
  <% end %>
  <a href="#" class="full-screen"><i class="fa fa-expand"></i> <span><%= I18n.t('dashboard.enter_full_screen') %></span></a>
</div>

app/views/welcome/info_window.html.erb
<div class="info_window">
  <h3><%= translate_model(Response) %> #<%= @response.id %></h3>
  <table>
    <tr>
      <td><%= translate_model(Form) %></td>
      <td><%= @response.form.try(:name) %></td>
    </tr>
    <tr>
      <td><%= t('activerecord.attributes.response.user_id') %></td>
      <td><%= @response.user.try(:name) %></td>
    </tr>
    <tr>
      <td><%= t('activerecord.attributes.response.created_at') %></td>
      <td><%= l(@response.created_at) %></td>
    </tr>
  </table>
  <%= link_to(t('response.view_response'), @response) %>
</div>

app/views/welcome/no_mission.html.erb
<% @title = t("welcome.no_mission_selected.title") %>
<% if current_user.admin? %>
  <% if Mission.any? %>
    <%= t("welcome.no_mission_selected.choose_or_create") %>
  <% else %>
    <%= t("welcome.no_mission_selected.need_to_create") %>
  <% end %>
  <%= link_to(t("welcome.no_mission_selected.create_link"), new_mission_path(mode: "admin")) %>.
<% else %>
  <% if Mission.any? %>
    <%= t("welcome.no_mission_selected.choose") %>
  <% else %>
    <%= t("welcome.no_mission_selected.no_missions") %>
  <% end %>
<% end %>

app/views/welcome/unauthorized.html.erb
<%= t('unauthorized.default') %>